use `ombutel`;

-- add direct cfi
insert into `ombu_feature_codes` (
	`feature_code_group_id`,
	`feature_name`,
	`description`,
	`defaultnumber`,
	`func`,
	`prefix`,
	`sufix`,
	`sendlength`,
	`param01`,
	`param02`,
	`state`,
	`edit`,
	`generate`,
	`display`
) values (
	6,
	'direct_toggle_cfi',
	'Direct Call Forward Immediately',
	'*59',
	'sub-direct-cfi',
	'_',
	'*[+*#0-9].',
	'yes',
	'call-fwd-unconditional',
	'CFI',
	'yes',
	'yes',
	'yes',
	'no'
);

-- add direct unpause/pause queue agent
insert into `ombu_feature_codes` (
	`feature_code_group_id`,
	`feature_name`,
	`description`,
	`defaultnumber`,
	`func`,
	`prefix`,
	`sufix`,
	`sendlength`,
	`state`,
	`edit`,
	`generate`,
	`display`
) values (
	5,
	'direct_pause_unpause_queue_agent',
	'Direct Pause/Unpause Queue Agent',
	'*51',
	'sub-direct-queue-pause-agent',
	'_',
	'*[+*#0-9].',
	'yes',
	'yes',
	'yes',
	'yes',
	'no'
);

-- add direct add/remove queue agent
insert into `ombu_feature_codes` (
	`feature_code_group_id`,
	`feature_name`,
	`description`,
	`defaultnumber`,
	`func`,
	`prefix`,
	`sufix`,
	`sendlength`,
	`state`,
	`edit`,
	`generate`,
	`display`
) values (
	5,
	'direct_add_remove_queue_agent',
	'Direct Add/Remove Queue Agent',
	'*50',
	'sub-direct-queue-agent',
	'_',
	'*[+*#0-9].',
	'yes',
	'yes',
	'yes',
	'yes',
	'no'
);

-- add direct voicemail using *95*[extension number]
insert into `ombu_feature_codes` (
	`feature_code_group_id`,
	`feature_name`,
	`defaultnumber`,
	`func`,
	`prefix`,
	`sufix`,
	`sendlength`,
	`state`,
	`edit`,
	`generate`,
	`display`
) values (
	13,
	'send_vm_msg_ver1',
	'*95',
	'send-vm-msg-ver1',
	'_',
	'*[+*#0-9].',
	'yes',
	'yes',
	'yes',
	'yes',
	'no'
);

update `ombu_feature_codes` set `sufix` = '[+#0-9].' where `func` = 'send-vm-msg';
