(function () {
	$('#status_report_form button.frmactions-refresh').bind('click', function() {
		$.ajax({
			type: "POST",
			dataType: "json",
			data: { class: "status_report", method: "refresh_report"},
			success: function(response) {
				update_sip_registration(response.sip_registrations);
				update_iax_registration(response.iax_registrations);
				update_channels(response.channels);
				update_channels_summary(response.channel_summary);
				update_sip_peers(response.sip_peers);
				update_iax_peers(response.iax_peers);
				update_hints(response.hints);
				update_voicemail(response.voicemail_list);
				update_queues(response.queue_status);
			}
		});
	});
})();

function update_sip_registration(sip_registrations) {
	var sip_registrations_table = $('#status_report_form div#status_reportregistrations table.sip_registration');
	$(sip_registrations_table).find('tbody tr').remove();
	$(sip_registrations).each(function(i, elem) {
		$(sip_registrations_table).find('tbody').append(
			$('<tr>').append(
				$('<td>' + elem.host + '</td>'),
				$('<td>' + elem.username + '</td>'),
				$('<td>' + elem.state + '</td>'),
				$('<td>' + elem.time + '</td>')
			)
		);
	});
}

function update_iax_registration(iax_registrations) {
	var iax_registrations_table = $('#status_report_form div#status_reportregistrations table.iax_registration');
	$(iax_registrations_table).find('tbody tr').remove();
	$(iax_registrations).each(function(i, elem) {
		$(iax_registrations_table).find('tbody').append(
			$('<tr>').append(
				$('<td>' + elem.host + '</td>'),
				$('<td>' + elem.username + '</td>'),
				$('<td>' + elem.state + '</td>')
			)
		);
	});
}

function update_channels(channels) {
	var channels_table = $('#status_report_form div#status_reportchannels table.channels');
	$(channels_table).find('tbody tr').remove();
	$(channels).each(function(i, elem) {
		$(channels_table).find('tbody').append(
			$('<tr>').append(
				$('<td>' + elem.channel + '</td>'),
				$('<td>' + elem.callerid + '</td>'),
				$('<td>' + elem.exten + '</td>'),
				$('<td>' + elem.state + '</td>'),
				$('<td>' + elem.duration + '</td>')
			)
		);
	});
}

function update_channels_summary(channel_summary) {
	var channels_summary_table = $('#status_report_form div#status_reportchannels table.channels_summary');
	$(channels_summary_table).find('tbody tr').remove();
	$(channel_summary).each(function(i, elem) {
		$(channels_summary_table).find('tbody').append(
			$('<tr>').append(
				$('<td>' + elem.active_calls + '</td>'),
				$('<td>' + elem.active_channels + '</td>')
			)
		);
	});
}

function update_sip_peers(sip_peers) {
	var sip_peers_table = $('#status_report_form div#status_reportpeers table.sip_peers');
	$(sip_peers_table).find('tbody tr').remove();
	$(sip_peers).each(function(i, elem) {
		elem.acl = (elem.acl == true) ? '1': '';
		elem.address = (elem.address != null) ? elem.address : '';
		elem.dynamic = (elem.dynamic == true) ? '1': '';
		$(sip_peers_table).find('tbody').append(
			$('<tr>').append(
				$('<td>' + elem.type + '</td>'),
				$('<td>' + elem.name + '</td>'),
				$('<td>' + elem.address + '</td>'),
				$('<td>' + elem.port + '</td>'),
				$('<td>' + elem.dynamic + '</td>'),
				$('<td>' + elem.rport + '</td>'),
				$('<td>' + elem.comedia + '</td>'),
				$('<td>' + elem.acl + '</td>'),
				$('<td>' + elem.status + '</td>'),
				$('<td>' + elem.description + '</td>')
			)
		);
	});
}

function update_iax_peers(iax_peers) {
	var iax_peers_table = $('#status_report_form div#status_reportpeers table.iax_peers');
	$(iax_peers_table).find('tbody tr').remove();
	$(iax_peers).each(function(i, elem) {
		elem.acl = (elem.acl == true) ? '1': '';
		elem.address = (elem.address != null) ? elem.address : '';
		elem.port = (elem.port != null) ? elem.port : '';
		elem.dynamic = (elem.dynamic == true) ? '1': '';
		$(iax_peers_table).find('tbody').append(
			$('<tr>').append(
				$('<td>' + elem.type + '</td>'),
				$('<td>' + elem.name + '</td>'),
				$('<td>' + elem.address + '</td>'),
				$('<td>' + elem.port + '</td>'),
				$('<td>' + elem.dynamic + '</td>'),
				$('<td>' + elem.status + '</td>'),
				$('<td>' + elem.description + '</td>')
			)
		);
	});
}

function update_hints(hints) {
	var hints_table = $('#status_report_form div#status_reporthints table.hints');
	$(hints_table).find('tbody tr').remove();
	$(hints).each(function(i, elem) {
		$(hints_table).find('tbody').append(
			$('<tr>').append(
				$('<td>' + elem.exten + '</td>'),
				$('<td>' + elem.context + '</td>'),
				$('<td>' + elem.hint + '</td>'),
				$('<td>' + elem.status + '</td>')
			)
		);
	});
}

function update_voicemail(voicemails) {
	var voicemails_table = $('#status_report_form div#status_reportvoicemail table.voicemail_list');
	$(voicemails_table).find('tbody tr').remove();
	$(voicemails).each(function(i, elem) {
		$(voicemails_table).find('tbody').append(
			$('<tr>').append(
				$('<td>' + elem.mailbox + '</td>'),
				$('<td>' + elem.fullname + '</td>'),
				$('<td>' + elem.newmessages + '</td>')
			)
		);
	});
}

function update_queues(queue_status) {
	var queues_table = $('#status_report_form div#status_reportqueues');
	var queue_members = $('#status_report_form div#status_reportqueues');
	$(queues_table).find('tbody tr').remove();
	$(queue_members).find('tbody tr').remove();
	$(queue_status).each(function(i, queues) {
		$.each(queues, function(i1, queue) {
			queue.max = (queue.max == 0) ? string_queues_unlimited : queue.max;
			$(queues_table).find('.' + queue.queue_name + '_name').find('tbody').append(
				$('<tr>').append(
					$('<td>' + queue.calls + '</td>'),
					$('<td>' + queue.max + '</td>'),
					$('<td>' + queue.stategy + '</td>'),
					$('<td>' + queue.holdtime + '</td>'),
					$('<td>' + queue.talktime + '</td>'),
					$('<td>' + queue.weight + '</td>'),
					$('<td>' + queue.completed + '</td>'),
					$('<td>' + queue.abandoned + '</td>')
				)
			);
			$.each(queue.members, function(i2, member) {
				$(queue_members).find('.' + queue.queue_name + '_members').find('tbody').append(
					$('<tr>').append(
						$('<td>' + member.name + '</td>'),
						$('<td>' + member.location + '</td>'),
						$('<td>' + member.membership + '</td>'),
						$('<td>' + member.incall + '</td>'),
						$('<td>' + member.paused + '</td>')
					)
				);
			});
		});
	});
}
