(function () {
	var trunkForm = $('#trunks_form');
	var radioTech = trunkForm.find('#technology label.btn-radio');
	var inputTech = trunkForm.find('input[name=technology]');
	var trunkDigital = $("#trunk-digital");
	var trunktelephony = $("#trunk-telephony");
	var trunkh323 = $("#trunk-h323");
	var trunkConf = $("#trunk-Conf");
	var sip_source_ip_tab = $('#trunks_form div.pbx_module_tabs li a[href=#trunkssourceip]');
	var use_incoming_cid = $("#trunks_form #trunksgeneral input#use_incoming_cid");
	var diversion_sip_header = $("#trunks_form #trunksgeneral input#diversion_sipheader");
	var diversion_sip_header_labels = $("#trunks_form #trunksgeneral div.form-group-diversion_sipheader label");
	var h323_option_note = trunkForm.find('.h323_option');

	var sipTech = trunkForm.find('.sip-tech-trunk');
	var iaxTech = trunkForm.find('.iax-tech-trunk');
	var h323Tech = trunkForm.find('.h323-tech-trunk');
	var telephonyTech = trunkForm.find('.telephony-tech-trunk');
	var customTech = trunkForm.find('.custom-tech-trunk');

	$("#trunks_form").validate(Validations);
	if($('input#register_flag').prop('checked')) {
		$('input.register_string').prop('readonly', true);
	}

	radioTech.bind('click', function () {
		trunkTech($(this).children("input[type=radio]").val());
	});

	trunkTech();

	trunks_cos();

	Ombutel.on('click', '#btn-modal-codecs', function () {
		multiple_select('modal-codecs', 'trcodecs', 'tab_trunks', ',');
	});

	// Populate register sring if 'use default' checked
	$('input#outgoing_username, input#outgoing_remotesecret, input#outgoing_defaultuser, input#outgoing_host, input#outgoing_port').on('keyup', function() {
		if($('input#register_flag').prop('checked')) {
			switch (tech()) {
				case 'sip': {
					$('input.register_string').val(default_sip_reg_string());
					break;
				}
				case 'iax2':
				case 'iax': {
					$('input.register_string').val(default_iax_reg_string());
					break;
				}
			}
		}
	});

	// Switch between custom to default register string when checkbox is checked
	$('input#register_flag').bind('change', function () {
		var reg_string = $('input.register_string');
		var custom_sip_register_string = $('input.custom_sip_reg_string');
		var custom_iax_register_string = $('input.custom_iax_reg_string');
		var state = $(this).prop('checked');
		if(state) { //if checkbox is checked (default is used)
			reg_string.prop('readonly', true);
			switch (tech()) {
				case 'sip': {
					custom_sip_register_string.val(reg_string.val());
					reg_string.val(default_sip_reg_string()); // Fill the correct default string here
					break;
				}
				case 'iax2':
				case 'iax': {
					custom_iax_register_string.val(reg_string.val());
					reg_string.val(default_iax_reg_string()); // Fill the correct default string here
					break;
				}
			}
		} else { // use custom string
			reg_string.prop('readonly', false);
			switch (tech()) {
				case 'sip': {
					reg_string.val(custom_sip_register_string.val()); // Fill custom string
					break;
				}
				case 'iax2':
				case 'iax': {
					reg_string.val(custom_iax_register_string.val()); // Fill custom string
					break;
				}
			}
		}
	});

	// Generate SIP register string.
	// Default register string defined as: username[:remote_secret[:remote_user]]@host[:port]/extension
	function default_sip_reg_string() {
		var username = $('input#outgoing_username').val();
		var secret = $('input#outgoing_remotesecret').val();
		var remote_user = $('input#outgoing_defaultuser').val();
		var host = $('input#outgoing_host').val();
		var port = $('input#outgoing_port').val();
		var reg_string = username;
		if(typeof secret !== 'undefined' && secret.length > 0) {
			reg_string += ":" + secret;
			if(typeof remote_user !== 'undefined' && remote_user.length > 0) {
				reg_string += ":" + remote_user;
			}
		}
		if(typeof host !== 'undefined' && host.length > 0) {
			reg_string += "@" + host;
			if(typeof port !== 'undefined' && port.length > 0) {
				reg_string += ":" + port;
			}
		}
		if(typeof username !== 'undefined' && username.length > 0) {
			reg_string += "/" + username;
		}
		return reg_string;
	}

	// Generate IAX2 register string.
	// Default register string defined as: username[:remote_secret]@host[:port]
	function default_iax_reg_string() {
		var username = $('input#outgoing_username').val();
		var secret = $('input#outgoing_remotesecret').val();
		var host = $('input#outgoing_host').val();
		var port = $('input#outgoing_port').val();
		var reg_string = username;
		if(typeof secret !== 'undefined' && secret.length > 0) {
			reg_string += ":" + secret;
		}
		if(typeof host !== 'undefined' && host.length > 0) {
			reg_string += "@" + host;
			if(typeof port !== 'undefined' && port.length > 0) {
				reg_string += ":" + port;
			}
		}
		return reg_string;
	}

	// Return the selected technology
	function tech() {
		var selected_tech = radioTech.children("input[type=radio]:checked");
		if (typeof $('input#technology') === "undefined" || $('input#technology').length == 0) { // new trunk
			if(typeof radioTech.children("input[type=radio]:checked") !== "undefined" && selected_tech.length > 0 && selected_tech.val().length > 0) {
				return selected_tech.val();
			}
		} else { // edit trunk
			return $('input#technology').val();
		}
		return 'sip';
	}

	function trunkTech(technology) {
		var selTech = 'sip';
		var custom_sip_reg_string = $('input.custom_sip_reg_string');
		var custom_iax_reg_string = $('input.custom_iax_reg_string');
		var reg_string = $('input.register_string');

		if (typeof technology === "undefined") {
			if (inputTech.length) {
				selTech = inputTech.val();
			} else {
				selTech = radioTech.children("input[type=radio]:checked").val();
			}
		} else {
			selTech = technology;
		}

		var formgroup;
		var classTech;

		$(".iax-tech-trunk, .telephony-tech-trunk, .custom-tech-trunk, .sip-tech-trunk").each(function () {
			formgroup = $(this).attr('data-form-group');
			$(this).addClass('ignore');
			$("." + formgroup).hide();
		});

		trunkDigital.hide();
		trunktelephony.hide();
		trunkh323.hide();
		trunkConf.hide();

		switch (selTech) {
			case 'sip':
				classTech = sipTech;
				trunkDigital.show();
				trunkConf.show();
				custom_iax_reg_string.val(reg_string.val()); //keep custom string (iax)
				if($('input#register_flag').prop('checked')) {
					$('input.register_string').val(default_sip_reg_string()); //show sip default
				} else {
					$('input.register_string').val(custom_sip_reg_string.val()); //show sip custom
				}
				sip_source_ip_tab.show();
				h323_option_note.addClass('hidden');
				break;
			case 'iax':
			case 'iax2':
				classTech = iaxTech;
				trunkDigital.show();
				trunkConf.show();
				sip_source_ip_tab.hide();
				custom_sip_reg_string.val(reg_string.val()); //keep custom string (sip)
				if($('input#register_flag').prop('checked')) {
					$('input.register_string').val(default_iax_reg_string());
				} else {
					$('input.register_string').val(custom_iax_reg_string.val());
				}
				h323_option_note.addClass('hidden');
				toggle_custom_table('show');
				break;

			case 'telephony':
				classTech = telephonyTech;
				trunktelephony.show();
				trunkConf.show();
				sip_source_ip_tab.hide();
				h323_option_note.addClass('hidden');
				toggle_custom_table('hide');
				break;
			case 'h323': {
				classTech = h323Tech;
				trunkh323.show();
				trunkConf.show();
				h323_option_note.removeClass('hidden');
				toggle_custom_table('hide');
				sip_source_ip_tab.hide();
				break;
			}
		}
		if (classTech) {
			classTech.each(function () {
				formgroup = $(this).attr('data-form-group');
				$("." + formgroup).show();
				$(this).removeClass('ignore');
			});
		}
	}

	overwrite_cid();
	$('#trunksgeneral select#overwrite_cid').bind('change', function() {
		overwrite_cid();
	});

	// prevent generating sip header if use incomming id is disabled
	var set_restrictions = function() {
		if(!use_incoming_cid.prop('checked')) {
			diversion_sip_header.bootstrapToggle('off');
		}
		gray_out(use_incoming_cid,diversion_sip_header,diversion_sip_header_labels);
	}

	use_incoming_cid.on('change', function() {
		set_restrictions();
	});
	set_restrictions();

	trunktelephony.find("input[name='dst_type']").on('change', function() {
		toggle_dst_type($(this).val())
	});
	toggle_dst_type(trunktelephony.find("input[name='dst_type']:checked").val());
})();

function toggle_dst_type(value) {
	var trunktelephony = $("#trunk-telephony");
	var channels = trunktelephony.find(".form-group-channel_id");
	var group = trunktelephony.find(".form-group-group_id");
	var group_mode = trunktelephony.find(".form-group-group_mode");
	if (value == "groups") {
		channels.hide();
		group.show();
		group_mode.show();
	} else {
		channels.show();
		group.hide();
		group_mode.hide();
	}
}

function overwrite_cid() {
	var overwrite_cid_val = $('#trunksgeneral select#overwrite_cid').val();
	var use_incoming_cid = $('#trunksgeneral input#use_incoming_cid');
	if (overwrite_cid_val != 'yes') {
		use_incoming_cid.bootstrapToggle('enable');
	} else {
		use_incoming_cid.bootstrapToggle('disable');
	}
}

// telephony and h.323 has no meaning for variable type (pear,user,friend)
function toggle_custom_table(action) {
	var advanced_table = $('#trunks_form #trunksadvanced div#trunks-cust-conf table');
	if(action == 'show') {
		advanced_table.find('thead tr th:first-child').show();
		advanced_table.find('tbody tr td:first-child').show();
	} else {
		advanced_table.find('thead tr th:first-child').hide();
		advanced_table.find('tbody tr td:first-child').hide();
	}
}

function trunks_cos(){
	var trunk_cos_dd =  $("#trunks_form").find("#class_of_service_id");

	trunk_cos_dd.on('change',function(){
		var selected = $(this).val();
		if(selected != ''){
			BootstrapDialog.show({
				type: BootstrapDialog.TYPE_WARNING,
				title: trunks_cos_warning_title,
				message: trunks_cos_warning,
				buttons: [{
					label: trunks_cos_warning_confirm,
					cssClass: 'btn-warning',
					action: function(dialogItself) {
						$("#trunksgeneral input#cos_id_current").val(selected);
						dialogItself.close();
					}
				}, {
					label: trunks_cos_warning_cancel,
					cssClass: 'btn-primary',
					action: function(dialogItself) {
						var cos_id_current = $("#trunksgeneral input#cos_id_current").val();
						trunk_cos_dd.val(cos_id_current);
						dialogItself.close();
					}
				}]
			})
		} else {
			$("#trunksgeneral input#cos_id_current").val(selected);
		}
	});
}
